@warnings
@version 2.6
@script modeler
@name Dxf_Colors
main
{
//Find a free layer.
emptyLyr = lyrempty();

//Switch to that layer.
lyrsetfg(emptyLyr[1]);

//	new();
	curObj=Mesh(0);
	selmode(USER);
	editbegin();
	for(i=0; i<=255; i++)
	{
		if(i<10)
		{
			if(i==0)
			{
				v1=<0,0,0>;
				v2=<0,.1,0>;
				v3=<.1,.1,0>;
				v4=<.1,0,0>;
			}
			if(i>0 && i<7)
			{
				r=PI/180*(360/6)*(i - 1) ;
				x=1*cos(r);
				z=1*sin(r);
				v1=<0,.1,0>;
				v2=<0,.2,0>;
				v3=<x,.2,z>;
				v4=<x,.1,z>;
			}
			if(i>6)
			{
				v1=<0,.1+(.1*(i - 6)),0>;
				v2=<0,.2+(.1*(i - 6)),0>;
				v3=<.1,.2+(.1*(i - 6)),0>;
				v4=<.1,.1+(.1*(i - 6)),0>;
			}
		}
		if(i>=10 && i<250)
		{
			r=PI/180*(360/240)*(i - 10);
			x=1*cos(r);
			z=1*sin(r);
			if(i%2==0)
			{
				v1=<0,.5,0>;
				v2=<0,.6,0>;
				v3=<x,.6,z>;
				v4=<x,.5,z>;
			}
			else
			{
				v1=<0,.5,0>;
				v2=<x,.5,z>;
				v3=<x,.6,z>;
				v4=<0,.6,0>;
			}
		}
		if(i>=250)
		{
			v1=<0,.6+(.1*(i - 250)),0>;
			v2=<0,.7+(.1*(i - 250)),0>;
			v3=<.1,.7+(.1*(i - 250)),0>;
			v4=<.1,.6+(.1*(i - 250)),0>;
		}
		
		p[1]=addpoint(v1);
		p[2]=addpoint(v2);
		p[3]=addpoint(v3);
		p[4]=addpoint(v4);
		if(i<10) sname=string("srf00",i);
		else if(i<100) sname=string("srf0",i);
		else 
		sname="srf"+i.asStr();
		result=addpolygon(p, sname);
	}
	editend();
	moninit(255,"testing...");
	for(i=0;i<=255; i++)
	{
		vec=idx2col(i);
		if(i<10) sname=string("srf00",i);
		else if(i<100) sname=string("srf0",i);
		else 
		sname="srf"+i.asStr();
		curSurf=Surface(curObj, sname);
		
		vec.x*=255;
		vec.y*=255;
		vec.z*=255;
		curSurf.setValue(SURFCOLR,vec);
		monstep();
	}
	monend();

}

idx2col: i 
{
	var maxi;
	var inc=0.0;
	var curCol=<0.0, 0.0, 0.0>;
	var up2digts=0;

	if(i<10)
	{
		switch(i){
			case 1:				//1|0|0=4;
				curCol.x=1; curCol.y=0; curCol.z=0; //i=1;//Red
				break;
			case 2:				//1|1|0=6;
				curCol.x=1; curCol.y=1; curCol.z=0;//i=2;//Yellow
				break;
			case 3:				//0|1|0=2;
				curCol.x=0; curCol.y=1; curCol.z=0;//i=3;//Green
				break;
			case 4:				//0|1|1=3;
				curCol.x=0; curCol.y=1; curCol.z=1; //i=4;//Cyan
				break;
			case 5:				//0|0|1=1;
				curCol.x=0; curCol.y=0; curCol.z=1; //i=5;//Blue
				break;
			case 6:				//1|0|1=5;
				curCol.x=1; curCol.y=0; curCol.z=1; //i=6;//Magenta
				break;
			case 7:				//1|1|1=7;
				curCol.x=1; curCol.y=1; curCol.z=1; //i=7;//White
				break;
			default:			//case 0:Be defined by Layer
				curCol.x=0; curCol.y=0; curCol.z=0; //i=8;i=9;//Undefined Black
				break;
		}
	}//i<10 END	
	
	else if(i<250)
	{
		up2digts =(i/10).asInt(); // Extract upper 2 digits of 10 TO 249
		inc=.25;
		switch(up2digts)
		{
			case 1:	case 2:	case 3:	case 4://10red TO 40orange
				curCol.x=1; curCol.y=(up2digts - 1)*inc; curCol.z=0;
				break;
			case 5:	case 6:	case 7:	case 8:			//50yellow TO 80yellow green
				curCol.x=1 - (up2digts - 5)*inc; curCol.y=1; curCol.z=0;
				break;
			//90{0,1,0}green//100{0,1,.25}green turqoise//110{0,1,.5}turqouise//120{0,1,.75}blueTurqoise
			case 9:	case 10: case 11: case 12:
				curCol.x=0; curCol.y=1; curCol.z=(up2digts - 9)*inc;
				break;
			case 13: case 14: case 15: case 16://{0,1,1};130cyan//{0,.75,1};140//{0,.5,1};150//{0,.25,1};160	
				curCol.x=0; 
				curCol.y=1 - (up2digts - 13)*inc; 
				curCol.z=1;
				break;
			//{0,0,1};170blue//{.25,0,1};180blue violet//{.5,0,1};190violet//{.75,0,1};200violet magenta
			case 17: 
			case 18: 
			case 19: 
			case 20:
				curCol.x=(up2digts - 17)*inc; curCol.y=0; curCol.z=1;
				break;
			//{1,0,1};210magenta;//{1,0,.75}; 220 reddish magenta//{1,0,.5}; 230 cinnabar//{1,0,.25}; 240 reddish cinnabar
			case 21: case 22: case 23: case 24:
				curCol.x=1; curCol.y=0; curCol.z=1 - (up2digts - 21)*inc; 
				break;
			default:
				break;
		}//switch((int)i/10) END

		switch(i%10)
		{
			case 2:	case 3:			//12 TO 242;//13 TO 243;
				curCol.x*=.65; curCol.y*=.65; curCol.z*=.65;
				break;
			case 4:	case 5:			//14 TO 244;//15 TO 245;
				curCol.x*=.5; curCol.y*=.5; curCol.z*=.5;
				break;
			case 6:	case 7:			//16 TO 246;//17 TO 247;
				curCol.x*=.3; curCol.y*=.3; curCol.z*=.3;
				break;
			case 8: case 9:			//18 TO 248;//19 TO 249;
				curCol.x*=.15; curCol.y*=.15; curCol.z*=.15;
				break;
			default:			//case 0://10 TO 240;//case 1://11 TO 241;
				break;
		}//switch (i%10) END

		//get maxiimum value among the R,G,B which got decayed 
		//by (*.65, *.5, *.3, *.15) in the last switch
		maxi=max(max(curCol.x, curCol.y),curCol.z);
		
		switch(i%10)
		{
			//11 TO 241;//13 TO 243;//15 TO 245;//17 TO 247;//19 TO 249; // Care odd cases
			case 1:	case 3:	case 5:	case 7:	case 9:
				curCol.x=curCol.x/2+maxi/2; curCol.y=curCol.y/2+maxi/2; curCol.z=curCol.z/2+maxi/2;
				break;
			default:
			//case 0://10 TO 240;//case 2://12 TO 242;//case 4://14 TO 244;//case 6://16 TO 246;//case 8://18 TO 248;
				break;
		}//switch (i%10) END
	}//i<250 END
	else if(i>=250)
	{
		curCol.x=.33; curCol.y=.33; curCol.z=.33;
		inc=.134;
		curCol.x=curCol.x+(i - 250)*inc; 
		curCol.y=curCol.y+(i - 250)*inc; 
		curCol.z=curCol.z+(i - 250)*inc;
	}
	//printf("dxfColor%d: rgb<%.4f, %.4f, %.4f>\n", i, curCol.x, curCol.y, curCol.z);
	return (curCol);
}
